diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
index 3e5d6e048..8f049ddda 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
@@ -2,101 +2,94 @@ package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FlagRenderer;
-import net.minecraft.client.render.model.ModelFlag;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlag;
 
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.wind.WindProvider;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
 
 public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
 {
 
-	public final Minecraft mc = Minecraft.getMinecraft();
-    private final ModelFlag modelFlag;
-    private final ModelFlag modelFlagMirrored;
-    private static FlagRenderer flagRenderer = null;
-    
-    public TileEntityRendererFlag()
-    {
-        modelFlag = new ModelFlag(false);
-        modelFlagMirrored = new ModelFlag(true);
+    private final @NotNull FlagRenderer flagRenderer = new FlagRenderer(Minecraft.getMinecraft().textureManager);
+    public final Minecraft mc = Minecraft.getMinecraft();
+
+    public TileEntityRendererFlag() {
+        super();
     }
 
     @Override
-    public void doRender(Tessellator tessellator, TileEntityFlag tileEntity, double x, double y, double z, float partialTick) {
-        World theWorld = Minecraft.getMinecraft().currentWorld;
-        int blockUnder = theWorld.getBlockId(tileEntity.x, tileEntity.y - 1, tileEntity.z);
-        boolean shortPole = blockUnder == Blocks.FLAG.id();
+    public void doRender(final @NotNull Tessellator tessellator, @NotNull final TileEntityFlag tileEntity, final double x, final double y, final double z, final float partialTick) {
+        final World theWorld = Minecraft.getMinecraft().currentWorld;
+        final int blockUnder = theWorld.getBlockId(tileEntity.x, tileEntity.y - 1, tileEntity.z);
+        final boolean shortPole = blockUnder == Blocks.FLAG.id();
 
-        WindProvider theWind = mc.currentWorld.getWorldType().getWindManager();
+        final WindProvider theWind = this.mc.currentWorld.getWorldType().getWindManager();
 
-        float windDirection = theWind.getWindDirection(mc.currentWorld, 0.0f, 500.0f, 0.0f) * 360f;
-        float windIntensity = theWind.getWindIntensity(mc.currentWorld, 0.0f, 500.0f, 0.0f);
+        final float windDirection = theWind.getWindDirection(this.mc.currentWorld, 0.0f, 500.0f, 0.0f) * 360f;
+        final float windIntensity = theWind.getWindIntensity(this.mc.currentWorld, 0.0f, 500.0f, 0.0f);
         
-        doRender(tileEntity, x, y, z, partialTick, shortPole, windDirection, windIntensity);
+        doRender(tessellator, tileEntity, x, y, z, partialTick, shortPole, windDirection, windIntensity);
     }
 
     private long lastTick = 0;
-    public void doRender(TileEntityFlag tileEntityFlag, double x, double y, double z, float partialTick, boolean shortPole, float windDirection, float windIntensity)
+    public void doRender(final @NotNull Tessellator tessellator, final @NotNull TileEntityFlag tileEntityFlag, final double x, final double y, final double z, final float partialTick, final boolean shortPole, final float windDirection, final float windIntensity)
     {
-        World theWorld = Minecraft.getMinecraft().currentWorld;
-        if (flagRenderer == null)
-        {
-            flagRenderer = new FlagRenderer(renderDispatcher.textureManager);
-        }
-
-        if (theWorld.getWorldTime() != lastTick) {
-            lastTick = theWorld.getWorldTime();
-            flagRenderer.tick();
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        final World theWorld = this.mc.currentWorld;
+        if (theWorld.getWorldTime() != this.lastTick) {
+            this.lastTick = theWorld.getWorldTime();
+            this.flagRenderer.tick();
         }
         
-        float swayInterpolated = tileEntityFlag.sway + partialTick;
+        final float swayInterpolated = tileEntityFlag.sway + partialTick;
         
         float sway = (float) ((swayInterpolated / 1.5) % (2 * Math.PI));
         sway = (float) (Math.sin(sway) * windIntensity * 2.0f);
         
         GL11.glPushMatrix();
-        final float scale = 1F;
-        GL11.glTranslatef((float) x + 0.5F, (float) y + 0.75F * scale, (float) z + 0.5F);
-        GL11.glScalef(scale, -scale, -scale);
-        loadTexture("/assets/minecraft/textures/entity/flag.png");
-        if (shortPole)
-        {
-            modelFlag.renderPoleShort();
-        }
-        else
-        {
-            modelFlag.renderBase();
-            modelFlag.renderPole();
+        GL11.glTranslatef((float) x + 0.5F, (float) y, (float) z + 0.5F);
+        GL11.glScalef(1/16F, 1/16F, -1/16F);
+        bindTexture("/assets/minecraft/textures/entity/flag.png");
+        final StaticEntityModel flagModel = shortPole ? getModel("pole.short") : getModel("pole.long");
+
+        if (shortPole) {
+            GL11.glTranslatef(0, 18, 0);
         }
-        
-        GL11.glPushMatrix();
-        GL11.glRotatef(windDirection + sway, 0.0f, 1.0f, 0.0f);
-        modelFlag.renderFlag();
-        renderDispatcher.textureManager.bindTexture(flagRenderer.getTexture(tileEntityFlag));
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_ONE_MINUS_SRC_COLOR, GL11.GL_SRC_COLOR);
+
+        flagModel.getTransform("flag").rotY = (windDirection + sway) * MathHelper.DEG_TO_RAD;
+        flagModel.render(tessellator);
+
+        flagModel.translateToBone("flag");
+        bindTexture("/assets/minecraft/textures/entity/flag_ui.png");
         if (tileEntityFlag.getFlipped()) {
-            modelFlagMirrored.renderFlagOverlay();
+            getModel("cloth.mirror").render(tessellator);
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glBlendFunc(GL11.GL_ONE_MINUS_SRC_COLOR, GL11.GL_SRC_COLOR);
+            this.renderDispatcher.textureManager.bindTexture(this.flagRenderer.getTexture(tileEntityFlag));
+            getModel("cloth.mirror").render(tessellator);
         } else {
-            modelFlag.renderFlagOverlay();
+            getModel("cloth").render(tessellator);
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glBlendFunc(GL11.GL_ONE_MINUS_SRC_COLOR, GL11.GL_SRC_COLOR);
+            this.renderDispatcher.textureManager.bindTexture(this.flagRenderer.getTexture(tileEntityFlag));
+            getModel("cloth").render(tessellator);
         }
         GL11.glDisable(GL11.GL_BLEND);
+
         GL11.glPopMatrix();
-        final float f4 = 0.01666667F * scale;
-        GL11.glTranslatef(0.0F, 0.5F * scale, 0.07F * scale);
-        GL11.glScalef(f4, -f4, f4);
-        GL11.glNormal3f(0.0F, 0.0F, -1F * f4);
-        GL11.glPopMatrix();
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     @Override
-    public void onWorldChanged(World world) {
-        if (flagRenderer != null) {
-            flagRenderer.flushCaches();
-        }
+    public void onWorldChanged(final World world) {
+        this.flagRenderer.flushCaches();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
index 90b124037..ff11bfdb8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
@@ -5,6 +5,7 @@ import java.util.Map;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
@@ -32,7 +33,7 @@ public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityM
         Entity entity = entityHashMap.get(mobSpawner.getMobId());
         if(entity == null)
         {
-            entity = EntityDispatcher.createEntityInWorld(mobSpawner.getMobId(), null);
+            entity = EntityDispatcher.createEntityInWorld(mobSpawner.getMobId(), WorldClient.EMPTY_WORLD);
             entityHashMap.put(mobSpawner.getMobId(), entity);
         }
         if(entity != null)
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 345adb7fa..6a77c86eb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -3,7 +3,6 @@ package net.minecraft.client.render.tileentity;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.model.ModelSign;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -12,38 +11,43 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSign;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 {
 
     private final Minecraft mc = Minecraft.getMinecraft();
-    private final ModelSign modelSign;
+    private final @NotNull StringBuilder builder = new StringBuilder();
 
-    public TileEntityRendererSign()
-    {
-        modelSign = new ModelSign();
+    public TileEntityRendererSign() {
+        super();
     }
 
      @Override
-	public void doRender(Tessellator t, TileEntitySign tileEntity, double x, double y, double z,
-                         float partialTick)
-    {
-        Block<?> block = tileEntity.getBlock();
+	public void doRender(final @NotNull Tessellator t, final @NotNull TileEntitySign tileEntity, final double x, final double y, final double z, final float partialTick) {
+        final Block<?> block = tileEntity.getBlock();
         if (block == null || !(block.getLogic() instanceof BlockLogicSign)) return; // Check to make sure the block for the entity is present before rendering, some edge cases have the tile entity loaded before the block data and can cause a crash
 
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glPushMatrix();
-        float scale = 2/3f;
-        GL11.glTranslatef((float)x + 0.5F, (float)y + 0.75F * scale, (float)z + 0.5F);
+
+        final StaticEntityModel model;
+
+        final float scale = 2/3f * 1/16f;
+        final float height;
+        GL11.glTranslatef((float)x + 0.5F, (float)y, (float)z + 0.5F);
         if (((BlockLogicSign) block.getLogic()).isFreeStanding) {
-            float angle = (float)(tileEntity.getBlockMeta() * 360) / 16F;
+            final float angle = (float)(tileEntity.getBlockMeta() * 360) / 16F;
             GL11.glRotatef(-angle, 0.0F, 1.0F, 0.0F);
-            modelSign.signStick.visible = true;
+            model = getModel("post");
+            height = 20;
         } else {
-            float angle;
+            final float angle;
             switch (tileEntity.getBlockMeta()) {
                 case BlockLogicSign.SIDE_NORTH:
                     angle = 180F;
@@ -60,27 +64,29 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
                     break;
             }
             GL11.glRotatef(-angle, 0.0F, 1.0F, 0.0F);
-            GL11.glTranslatef(0.0F, -0.3125F, -0.4375F);
-            modelSign.signStick.visible = false;
+            GL11.glTranslatef(0, 0, -11 * scale);
+            model = getModel("wall");
+            height = 13;
         }
 
         GL11.glPushMatrix();
-        GL11.glScalef(scale, -scale, -scale);
-        loadTexture("/assets/minecraft/textures/entity/sign.png");
-        modelSign.render();
+        GL11.glScalef(scale, scale, -scale);
+        bindTexture("/assets/minecraft/textures/entity/sign.png");
+        model.render(t);
         GL11.glPopMatrix();
 
         // Render overlay
         GL11.glPushMatrix();
-        GL11.glTranslatef(0, 5.3672f/16f, 0.7f/16f);
+        GL11.glTranslatef(0 * scale, height * scale, 1.05f * scale);
+        GL11.glNormal3f(0, 0, 1);
         GL11.glDepthMask(false);
-        EnumSignPicture picture = tileEntity.getPicture();
+        final EnumSignPicture picture = tileEntity.getPicture();
         drawTexturedModalRect(1, 0.5,TextureRegistry.getTexture(picture.getTextureKey()));
         GL11.glPopMatrix();
 
         // Render text
-        FontRenderer sr = getFont();
-        float lightLevel = LightmapHelper.isLightmapEnabled() ? 1 : mc.currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
+        final FontRenderer sr = getFont();
+        float lightLevel = (LightmapHelper.isLightmapEnabled() || this.mc.isFullbrightEnabled()) ? 1 : this.mc.currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         float lightOffset = 0f;
         if (tileEntity.isGlowing()) {
             lightLevel = 1f;
@@ -92,23 +98,25 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         }
 
         GL11.glPushMatrix();
-        float scale2 = 0.01666667F * scale;
-        GL11.glTranslatef(0.0F, 0.5F * scale, 0.065F * scale);
-        GL11.glScalef(scale2, -scale2, scale2);
-        GL11.glDepthMask(false);
+        final float scale2 = 0.2666667f * scale;
+         GL11.glTranslatef(0.0F, 20 * scale, 1.1f * scale);
+         GL11.glScalef(scale2, -scale2, scale2);
+         GL11.glDepthMask(false);
         int color = Colors.allSignColors[tileEntity.getColor().id].getARGB();
-        int r = (int) MathHelper.clamp(((color >> 16) & 0xFF) * lightLevel + lightOffset, 0, 255);
-        int g = (int)MathHelper.clamp(((color >>  8) & 0xFF) * lightLevel + lightOffset, 0, 255);
-        int b = (int)MathHelper.clamp(((color >>  0) & 0xFF) * lightLevel + lightOffset, 0, 255);
-        color = (r << 16) | (g << 8) | (b << 0);
+        final int r = (int) MathHelper.clamp((Color.redFromInt(color) * lightLevel + lightOffset), 0, 255);
+        final int g = (int)MathHelper.clamp((Color.greenFromInt(color) * lightLevel + lightOffset), 0, 255);
+        final int b = (int)MathHelper.clamp((Color.blueFromInt(color) * lightLevel + lightOffset), 0, 255);
+        color = Color.intToIntARGB(0, r, g, b);
         for(int line = 0; line < tileEntity.signText.length; line++)
         {
-            String text = tileEntity.signText[line];
+            this.builder.setLength(0);
             if(line == tileEntity.lineBeingEdited)
             {
-                text = "> " + text + " <";
+                this.builder.append("§+§0> §-").append(tileEntity.signText[line]).append("§+§0 <§-");
+            } else {
+                this.builder.append(tileEntity.signText[line]);
             }
-            sr.render(t, text, -sr.stringWidth(text) / 2, line * 10 - tileEntity.signText.length * 5).setColor(color).call();
+            sr.render(t, this.builder, -sr.stringWidth(this.builder) / 2, line * 10 - tileEntity.signText.length * 5).setColor(color).call();
         }
         GL11.glPopMatrix();
 
@@ -118,10 +126,10 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    private void drawTexturedModalRect(double width, double height, IconCoordinate coordinate)
+    private static void drawTexturedModalRect(final double width, final double height, final @NotNull IconCoordinate coordinate)
     {
         coordinate.parentAtlas.bind();
-        Tessellator tessellator = Tessellator.instance;
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(-width/2,  height/2, 0, coordinate.getIconUMin(),coordinate.getIconVMin());
         tessellator.addVertexWithUV(-width/2, -height/2, 0, coordinate.getIconUMin(),coordinate.getIconVMax());
